<section class="section pt-5 pb-0 mb-0">
    <nav class="breadcrumb" aria-label="breadcrumbs">
        <ul>
            <li><a href="/app">Home</a></li>
            <li>
                <a href="/app/challenge/{{challenge.id}}">
                    {{challenge.name}}
                </a>
            </li>
            <li class="is-active">
                <a href="/app/challenge/{{challenge.id}}/settings" aria-current="page">Settings</a>
            </li>
        </ul>
    </nav>
  <h4 class="title is-size-4">
      Settings
  </h4>
    
    <div class="columns">
        <div class="column py-3">
            <h5 class="subtitle is-size-6">
                Challenge Settings
                {{#if challenge.active}}
                    <span class="tag is-success">Active</span>
                {{else}}
                    <span class="tag is-warning">Not Active</span>
                {{/if}}
            </h5>
            <form action="/app/challenge/{{challenge.id}}" method="post">
                {{> challengeForm btnTitle="Update"}}
            </form>
           
        </div>
        <div class="column py-3">
            <nav class="level">
                <div class="level-left">
                    <h5 class="level-item subtitle is-size-6">
                        Project Details
                    </h5>
                </div>
                <div class="level-right is-hidden">
                    {{!-- TODO: Manual refresh option --}}
                    <span class="tag is-success level-item">
                        <span class="icon-spin mr-2">
                            <ion-icon name="medical-outline"></ion-icon>
                        </span>
                        Refreshing
                    </span>
                    <button class="level-item button is-rounded is-primary is-inverted">
                        <span class="icon is-small">
                            <ion-icon name="refresh-circle-outline" size="small"></ion-icon>
                        </span>
                    </button>
                </div>
            </nav>
            {{#with challenge}}
                {{> glprojectcard}}
            {{/with}}
            <nav class="level mt-4">
                <div class="level-left">
                    <h5 class="level-item subtitle is-size-6">
                        Updates
                    </h5>
                </div>
            </nav>
            <div class="card">
                <div class="card-content">
                    <div class="field is-grouped">
                        <p class="control">
                            <button id="btnUpdateScores" class="button is-link">
                                Update Completion Scores
                            </button>
                        </p>
                        {{#if challenge.active}}
                            <p class="control">
                                <button id="btnDeactivate" class="button is-warning">
                                De-activate Challenge
                                </button>
                            </p>
                        {{else}}
                            <p class="control">
                                <button id="btnActivate" class="button is-success">
                                Activate Challenge
                                </button>
                            </p>
                        {{/if}}
                     <!--   <p class="control">
                            <button class="button is-danger">
                            Delete Challenge
                            </button>
                        </p>
                        -->
                    </div>
                    
                </div>
            </div>

            <hr/>
             <nav class="level mt-4">
                <div class="level-left">
                    <h5 class="level-item subtitle is-size-6">
                        Notification Settings
                    </h5>
                </div>
            </nav>
            <form action="/app/challenge/{{challenge.id}}/notifications" method="post">
                {{> notificationsForm}}
            </form>
        </div>
    </div>
</section>


{{#section "script"}}
<script>
    const btnUpdateScores = $("#btnUpdateScores");
    const btnDeactivate = $("#btnDeactivate");
    const btnActivate = $("#btnActivate");
    const btnTestWebhook = $("#btnTestWebhook");
    const challengeId = location.pathname.split("/")[3];
    const baseUrl = `${location.protocol}//${location.host}`

    btnTestWebhook.click(function (e) {
        btnTestWebhook.addClass("is-loading");
        $.post(`/app/challenge/${challengeId}/testWebhook`) 
        .done(function (data) {
            btnTestWebhook.removeClass("is-loading");
            btnTestWebhook.addClass("is-success");
            btnTestWebhook.text("Webhook Test Successful");
        })
        .fail(function (data) {
            btnTestWebhook.removeClass("is-loading");
            btnTestWebhook.addClass("is-danger");
            btnTestWebhook.text("Webhook Test Failed");
        }).always(function () {
            setTimeout(function () {
                btnTestWebhook.removeClass("is-success");
                btnTestWebhook.removeClass("is-danger");
                btnTestWebhook.text("Test Webhook");
            }, 5000);
        });
    })

    btnUpdateScores.click((e) => {
        btnUpdateScores.addClass("is-loading");
        $.get(`${baseUrl}/api/v1/public/update/challenge/${challengeId}`, (v) => {
            console.log(v);
        }).always(() => btnUpdateScores.removeClass('is-loading'));
    })

    btnActivate.click(() => {
        btnDeactivate.addClass("is-loading");
        $.ajax({
            url: `/api/v1/challenge/${challengeId}/activate`,
            method: 'PUT'
        })
        .done((v) => location.reload())
        .always(() => btnDeactivate.removeClass("is-loading"))
    })

    btnDeactivate.click(() => {
        btnDeactivate.addClass("is-loading");
        $.ajax({
            url: `/api/v1/challenge/${challengeId}/deactivate`,
            method: 'PUT'
        })
        .done((v) => location.reload())
        .always(() => btnDeactivate.removeClass("is-loading"))
    })
</script>
{{/section}}